

/*

**	name:	     Command Line ms2pdf

**

**	purpose:     Convert an MS document to PDF

**

**	Setup:       Should be run on a Windows machine where MS Office

**		     has been installed.  The Adobe Acrobat PDF Writer

**		     should be installed.

*/



#include "stdafx.h"

#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <iostream.h>

#include <io.h>

#include <mmsystem.h>

#include "debuglog.h"



char	lgsys[50];

char	logn[50];



extern int lock();

extern void unlock();

VOID CALLBACK MyTimer(HWND, UINT, UINT, DWORD);

extern void oleAbort();

extern int diffVer(char*, char*, char*, char*);


int main(int argc, char* argv[])

{

	int	ret;

	char	msfile[500];

	char	msfile2[500];

	char	psfile[500];

	char*   docType;



	extern void init_debuglog(void);

	init_debuglog();

	strcpy(lgsys, "none");

	strcpy(logn, "none");



	if (argc != 4 && argc != 5)

	{

		cout << "\n\nUsage: Bms2pdf <txttype> <sourceFile> <outFile>\n";

		return 1;

	}



	if (argc == 4)

	{

		docType= argv[1];

		strcpy(msfile, argv[2]);

		strcpy(psfile, argv[3]);

	}

	else

	{

		docType= argv[1];

		strcpy(msfile, argv[2]);

		strcpy(msfile2, argv[3]);

		strcpy(psfile, argv[4]);

	}



	debuglog ("starting Bms2pdf...\n");

	while (!lock())

	{

		Sleep(500);

	}



	/*

	**	Set timer to go off after 10 minutes.

	UINT mills = 600000;  // 10 minutes

	if (timeSetEvent(mills, 1000, (LPTIMECALLBACK) MyTimer, NULL, 

		TIME_ONESHOT) == 0)

	{

		cout << "\nCan't set timer.\n";

		debuglog("Can't set timer.\n");

		unlock();

		return 1;

	}

	*/



	extern int ms2pdf(char*, char*, char*);

	debuglog("starting %s...\n", docType);



	if (!strcmp(docType, "msdiff"))

	{

		ret = diffVer(docType, msfile, msfile2, psfile);

	}

	else

	{

		ret = ms2pdf(docType, msfile, psfile);

	}

	if (ret != 0)

	{

		cout << "\nTrouble in OLE Object.\n";

		debuglog("Trouble in OLE Object.\n");

		unlock();

		return 1;

	}



	char buf[200];

	char* ptr;

	if ((ptr = strchr(psfile, '.')) == NULL)

	{

		sprintf(buf, "%s.log", psfile);

	}

	else

	{

		strcpy(ptr+1, "log");

		strcpy(buf, psfile);

	}

	//unlink(buf);

	//unlink("C:\\distOut.ps");



	unlock();

	return 0;

}



VOID CALLBACK MyTimer(HWND hwnd, UINT msg, UINT idTimer, DWORD dwTimer)

{

	debuglog("Bms2pdf timed out!\n");

	unlock();

	oleAbort();

	abort();

}

