/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FASSERT_H
#define FASSERT_H

#ifdef __cplusplus
extern "C" {
#endif

typedef VoidT (*F_AssertProcT) FARGS((VoidT));
typedef VoidT (*F_ExitProcT) FARGS((VoidT));

extern F_AssertProcT F_SetAssert FARGS((F_AssertProcT myHandler));
extern F_ExitProcT F_SetDSExit FARGS((F_ExitProcT myHandler));
extern VoidT FdeFail FARGS((VoidT));
extern VoidT F_Exit FARGS((IntT));
extern BoolT FdeSetStrictEnforcement FARGS((BoolT));

#define F_Assert(p)\
do { if (!(p)) FdeFail(); } while (0)

#define F_EnforcementAssert(p)\
do { if (!(p)) FdeEnforcement(); } while (0)

#ifdef __cplusplus
}
#endif

#endif /* FASSERT_H */
