/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FENCODE_H
#define FENCODE_H

#ifdef  __cplusplus
extern "C" {
#endif

typedef UIntT FontEncIdT;

/* This has some relationship to F_FontEncodingT internal to FM. */
typedef struct {
	UCharT firstBytes[256]; /* First byte character information */
	UCharT secondBytes[256]; /* Second byte character information */
	StringT name; /* The name of the encoding */
} F_FontEncT;

extern F_FontEncT *fdeFontEncs[];

extern FontEncIdT fdeFrameRomanEncodingId;
extern FontEncIdT fdeJISX0208_ShiftJISEncodingId;
extern FontEncIdT fdeKSC5601_1992EncodingId;
extern FontEncIdT fdeBIG5EncodingId;
extern FontEncIdT fdeGB2312_80_EUCEncodingId;
extern FontEncIdT fdeLastEncodingId;

extern FontEncIdT fdeDialogEncodingId;

#define fdeDialogEncodingIsFrameRoman (fdeDialogEncodingId == fdeFrameRomanEncodingId)

#define F_CharIsDoubleByteFirst(c, feId) (fdeFontEncs[feId]->firstBytes[c])
#define F_CharIsDoubleByteSecond(c, feId) (fdeFontEncs[feId]->secondBytes[c])
#define F_CharIsDoubleByte(c1, c2, feId) \
	(F_CharIsDoubleByteFirst(c1, feId) && F_CharIsDoubleByteSecond(c2, feId))

extern FontEncIdT F_FdeInitFontEncs FARGS((ConStringT fontEncName));
extern ConStringT F_FontEncName FARGS((FontEncIdT fontEncId));
extern FontEncIdT F_FontEncId FARGS((ConStringT fontEncName));
extern StringT F_StrChrEnc FARGS((StringT s, PUCharT first, PUCharT second, FontEncIdT feId));
extern StringT F_StrRChrEnc FARGS((StringT s, PUCharT first, PUCharT second, FontEncIdT feId));
extern IntT F_StrStrEnc FARGS((ConStringT s1, ConStringT s2, FontEncIdT feId));
extern BoolT F_StrIEqualEnc FARGS((ConStringT s1, ConStringT s2, FontEncIdT feId));
extern BoolT F_StrIEqualNEnc FARGS((ConStringT s1, ConStringT s2, IntT n, FontEncIdT feId));
extern IntT F_StrICmpEnc FARGS((ConStringT s1, ConStringT s2, FontEncIdT feId));
extern IntT F_StrMCmpEnc FARGS((ConStringT s1, ConStringT s2, FontEncIdT feId));
extern IntT F_StrCmpNEnc FARGS((ConStringT s1, ConStringT s2, IntT n, FontEncIdT feId));
extern IntT F_StrICmpNEnc FARGS((ConStringT s1, ConStringT s2, IntT n, FontEncIdT feId));
extern NativeIntT F_StrQsortCmpEnc FARGS((ConStringT *s1, ConStringT *s2, FontEncIdT feId));
extern VoidT F_StrTruncEnc FARGS((StringT s, IntT n, FontEncIdT feId));
extern IntT F_StrLenEnc FARGS((ConStringT s, FontEncIdT feId));
extern IntT F_StrCatDblCharNEnc FARGS((StringT s, PUCharT first, PUCharT second, IntT n, FontEncIdT feId));
extern BoolT F_StrIPrefixEnc FARGS((ConStringT s1, ConStringT s2, FontEncIdT feId));
extern BoolT F_StrISuffixEnc FARGS((ConStringT s1, ConStringT s2, FontEncIdT feId));
extern IntT F_StrCatNEnc FARGS((StringT s1, ConStringT s2, IntT n, FontEncIdT feId));
extern IntT F_StrNCatNEnc FARGS((StringT s1, ConStringT s2, IntT m, IntT n, FontEncIdT feId));
extern IntT F_StrCpyNEnc FARGS((StringT s1, ConStringT s2, IntT n, FontEncIdT feId));

#ifdef  __cplusplus
}
#endif

#endif /* FENCODE_H */
