/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FHASH_H
#define FHASH_H

typedef struct hashtablet HashTableT;
typedef HashTableT* HashT; 

#define KEY_IS_STRING 32767

#ifdef  __cplusplus
extern "C" {
#endif

/* assumes INFO points to sizeof(StrBuffT) bytes (include trailing \0) */
extern IntT F_HashReportOnData FARGS((HashTableT *table, StringT info,
	GenericT datum));
/* NB this aliases NAME! */
/* NB stringifyMe must assume buffer size sizeof(StrBuffT) */
extern HashTableT *F_HashCreate FARGS((ConStringT name, IntT minsize,
	PShortT key_len, GenericT notfound, BoolT (*deadQuery)(GenericT),
	VoidT (*removeNotify)(GenericT), VoidT (*stringifyMe)(PtrT, UCharT *)));
extern ErrorT F_HashSet FARGS((HashTableT *table, PtrT key, GenericT datum));
extern GenericT F_HashGet FARGS((HashTableT *table, ConPtrT key));
extern VoidT F_HashRemove FARGS((HashTableT *table, PtrT key));
extern VoidT F_HashPrefixForget FARGS((HashTableT *table, PtrT key));
extern VoidT F_HashDestroy FARGS((HashTableT *table));
/* visit every member calling PROC(key, datum). */
extern VoidT F_HashEnumerate FARGS((HashTableT *table,
	IntT (*proc)(PtrT, GenericT)));

#ifdef  __cplusplus
}
#endif

#endif /* FHASH_H */
