/****************
 * THIS FILE IS AN INSTALLED COPY OF
 * .\fm_psr.h
 ****************/

/* DON'T EDIT THIS FILE DIRECTLY! */
#ifndef fm_psr_h
#define fm_psr_h
#ifdef __cplusplus
extern "C" {
#endif
/*<sgml_psr.c<*/
/*
 * COPYRIGHT (c) 1986-1998 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#include "fm_base.h"

/*
 * Quantity limits defined in the SGML standard.
 */
typedef enum {
	SGML_QTY_ATTCNT = 1,
	SGML_QTY_ATTSPLEN,
	SGML_QTY_BSEQLEN,
	SGML_QTY_DTAGLEN,
	SGML_QTY_DTEMPLEN,
	SGML_QTY_ENTLVL,
	SGML_QTY_GRPCNT,
	SGML_QTY_GRPGTCNT,
	SGML_QTY_GRPLVL,
	SGML_QTY_LITLEN,
	SGML_QTY_NAMELEN,
	SGML_QTY_NORMSEP,
	SGML_QTY_PILEN,
	SGML_QTY_TAGLEN,
	SGML_QTY_TAGLVL,
	SGML_QTY_MAX_VALUE
} SgmlQuantityTypeT;


/*
 * Delimiter roles defined in SGML.
 */
typedef enum {
	SGML_DE_AND = 1,
	SGML_DE_COM,
	SGML_DE_CRO,
	SGML_DE_DSC,
	SGML_DE_DSO,
	SGML_DE_DTGC,
	SGML_DE_DTGO,
	SGML_DE_ERO,
	SGML_DE_ETAGO,
	SGML_DE_GRPC,
	SGML_DE_GRPO,
	SGML_DE_LIT,
	SGML_DE_LITA,
	SGML_DE_MDC,
	SGML_DE_MDO,
	SGML_DE_MINUS,
	SGML_DE_MSC,
	SGML_DE_NET,
	SGML_DE_OPT,
	SGML_DE_OR,
	SGML_DE_PERO,
	SGML_DE_PIC,
	SGML_DE_PIO,
	SGML_DE_PLUS,
	SGML_DE_REFC,
	SGML_DE_REP,
	SGML_DE_RNI,
	SGML_DE_SEQ,
	SGML_DE_STAGO,
	SGML_DE_TAGC,
	SGML_DE_VI,
	SGML_DE_MAX_VALUE,
	XML_DE_NET
} SgmlDelimiterTypeT;

/*
 * SGML reserved names.
 */
typedef enum {
	SGML_RN_ANY = 1,
	SGML_RN_ATTLIST,
	SGML_RN_CDATA,
	SGML_RN_CONREF,
	SGML_RN_CURRENT,
	SGML_RN_DEFAULT,
	SGML_RN_DOCTYPE,
	SGML_RN_ELEMENT,
	SGML_RN_EMPTY,
	SGML_RN_ENDTAG,
	SGML_RN_ENTITIES,
	SGML_RN_ENTITY,
	SGML_RN_FIXED,
	SGML_RN_ID,
	SGML_RN_IDLINK,
	SGML_RN_IDREF,
	SGML_RN_IDREFS,
	SGML_RN_IGNORE,
	SGML_RN_IMPLIED,
	SGML_RN_INCLUDE,
	SGML_RN_INITIAL,
	SGML_RN_LINK,
	SGML_RN_LINKTYPE,
	SGML_RN_MD,
	SGML_RN_MS,
	SGML_RN_NAME,
	SGML_RN_NAMES,
	SGML_RN_NDATA,
	SGML_RN_NMTOKEN,
	SGML_RN_NMTOKENS,
	SGML_RN_NOTATION,
	SGML_RN_NUMBER,
	SGML_RN_NUMBERS,
	SGML_RN_NUTOKEN,
	SGML_RN_NUTOKENS,
	SGML_RN_O,
	SGML_RN_PCDATA,
	SGML_RN_PI,
	SGML_RN_POSTLINK,
	SGML_RN_PUBLIC,
	SGML_RN_RCDATA,
	SGML_RN_RE,
	SGML_RN_REQUIRED,
	SGML_RN_RESTORE,
	SGML_RN_RS,
	SGML_RN_SDATA,
	SGML_RN_SHORTREF,
	SGML_RN_SIMPLE,
	SGML_RN_SPACE,
	SGML_RN_STARTTAG,
	SGML_RN_SUBDOC,
	SGML_RN_SYSTEM,
	SGML_RN_TEMP,
	SGML_RN_USELINK,
	SGML_RN_USEMAP,
	SGML_RN_MAX_VALUE
} SgmlReservedNameT;


/*
 * SGML optional features
 */
typedef enum {
	SGML_FEAT_SHORTREF = 1,
	SGML_FEAT_DATATAG,
	SGML_FEAT_OMITTAG,
	SGML_FEAT_RANK,
	SGML_FEAT_SHORTTAG,
	SGML_FEAT_SIMPLE_LINK,
	SGML_FEAT_IMPLICIT_LINK,
	SGML_FEAT_EXPLICIT_LINK,
	SGML_FEAT_CONCUR,
	SGML_FEAT_SUBDOC,
	SGML_FEAT_FORMAL,
	SGML_FEAT_MAX_VALUE
} SgmlFeatureTypeT;

/*
 * entity name is name of a paramter entity without the initial pero
 * delimiter, or the name of a general entity.
 */
typedef enum {
	SGML_ES_GENERAL = 1,
	SGML_ES_PARAMETER,
	SGML_ES_MAX_VALUE
} SgmlEntityScopeT;


/*
 * SGML_ET_TEXT identifies an entity that is not declared with bracketed
 * text and is not a data entity or subdocument entity. Other values
 * distinguish various types of bracketed text, data entities, and 
 * subdocument entities.
 */
typedef enum {
	SGML_ET_TEXT = 1,
	SGML_ET_CDATA,
	SGML_ET_SDATA,
	SGML_ET_NDATA,
	SGML_ET_PI,
	SGML_ET_STARTTAG,
	SGML_ET_ENDTAG,
	SGML_ET_MS,
	SGML_ET_MD,
	SGML_ET_SUBDOC,
	SGML_ET_MAX_VALUE
} SgmlEntityTypeT;


/*
 * The declared value of an attribute
 */
typedef enum {
	SGML_AT_CDATA = 1,
	SGML_AT_ENTITY,
	SGML_AT_ENTITIES,
	SGML_AT_ID,
	SGML_AT_IDREF,
	SGML_AT_IDREFS,
	SGML_AT_NAME,
	SGML_AT_NAMES,
	SGML_AT_NMTOKEN,
	SGML_AT_NMTOKENS,
	SGML_AT_NOTATION,
	SGML_AT_NUMBER,
	SGML_AT_NUMBERS,
	SGML_AT_NUTOKEN,
	SGML_AT_NUTOKENS,
	SGML_AT_NMTOKENGRP,
	SGML_AT_MAX_VALUE
} SgmlAttrDeclaredValueT;


/*
 * Default value type of an SGML attribute.
 */
typedef enum {
	SGML_AV_FIXED = 1,
	SGML_AV_REQUIRED,
	SGML_AV_CURRENT,
	SGML_AV_CONREF,
	SGML_AV_IMPLIED,
	SGML_AV_DEFAULT,
	SGML_AV_MAX_VALUE
} SgmlAttrDefaultValueT;



/*
 * Whether element definition is a model group, ANY, or declared content.
 */
typedef enum {
	SGML_EC_MODEL_GROUP = 1,
	SGML_EC_ANY,
	SGML_EC_EMPTY,
	SGML_EC_CDATA,
	SGML_EC_RCDATA,
	SGML_EC_MAX_VALUE
} SgmlContentTypeT;


/*
 * Tokens in a model group
 */
typedef enum {
	SGML_CT_GRPO = 1,
	SGML_CT_GRPC,
	SGML_CT_PCDATA,
	SGML_CT_REP,
	SGML_CT_PLUS,
	SGML_CT_OPT,
	SGML_CT_SEQ,
	SGML_CT_AND,
	SGML_CT_OR,
	SGML_CT_NAME,
	SGML_CT_MAX_VALUE
} SgmlContentTokenT;



/********************************************************************
 * DATA STRUCTURES
 ********************************************************************/

/*
 * Attribute name/value pair
 */
typedef struct {
	StringT sgmlAttrName;
	StringListT sgmlAttrVal;

	IntT sgmlAttrFlags;
#define SGML_ATTR_VAL_SPECIFIED	0x0001
#define SGML_ATTR_IS_CDATA		0x0002
#define SGML_ATTR_IS_ID			0x0004
#define SGML_ATTR_IS_FIXED		0x0008
#define SGML_ATTR_IS_IDREF		0x0010
#define SGML_ATTR_IS_NAME_TOKEN	0x0020

} SgmlAttrValT;


#define Sgml_IsAttrValSpecified(attrValp)		\
		(((SgmlAttrValT *)attrValp)->sgmlAttrFlags & SGML_ATTR_VAL_SPECIFIED) 

#define Sgml_IsAttrCDATA(attrValp)		\
		(((SgmlAttrValT *)attrValp)->sgmlAttrFlags & SGML_ATTR_IS_CDATA) 

#define Sgml_IsAttrNameToken(attrValp)			\
		(((SgmlAttrValT *)attrValp)->sgmlAttrFlags & SGML_ATTR_IS_NAME_TOKEN)

#define Sgml_IsIdAttr(attrValp)					\
		(((SgmlAttrValT *)attrValp)->sgmlAttrFlags & SGML_ATTR_IS_ID)

#define Sgml_IsIdRefAttr(attrValp)					\
		(((SgmlAttrValT *)attrValp)->sgmlAttrFlags & SGML_ATTR_IS_IDREF)

#define Sgml_IsAttrFixed(attrValp)				\
		(((SgmlAttrValT *)attrValp)->sgmlAttrFlags & SGML_ATTR_IS_FIXED)


/*
 * List of attribute values associated with a start tag
 */
typedef struct {
	UIntT len;
	SgmlAttrValT *val;
} SgmlAttrValsT;


/*
 * Entity declaration information
 */
typedef struct {
	StringT ename;
	StringT etext;
	SgmlEntityScopeT escope;
	SgmlEntityTypeT etype;
	BoolT external;
	StringT pubid;
	StringT sysid;
	StringT nname;
	SgmlAttrValsT dataAttrVals;
	FilePathT *fp;
} SgmlEntityDefT;


/*
 * Attribute definition information.
 */
typedef struct {
	StringT attrName;
	SgmlAttrDeclaredValueT declVal;
	SgmlAttrDefaultValueT defValType;
	StringListT tokenGroup;
	StringListT defVal;
} SgmlAttrDefT;

typedef struct {
	UIntT len;
	SgmlAttrDefT *val;
} SgmlAttrDefsT;


/*
 * Notation definition
 */
typedef struct {
	StringT nname;
	StringT pubid;
	StringT sysid;
	SgmlAttrDefsT dataAttrs;
} SgmlNotationDefT;


/*
 * Element definition
 */
typedef struct {
	StringT gi;
	SgmlContentTypeT conType;
	UCharT *modelGroup;
	StringListT inclusions, exclusions;
	SgmlAttrDefsT attrs;

	IntT tagOmission;
#define OMIT_START_TAG  0x0001
#define OMIT_END_TAG    0x0002

	IntT reserved;
} SgmlElementDefT;


#define StartTagOmissible(edefp)    ((edefp)->tagOmission & OMIT_START_TAG)
#define EndTagOmissible(edefp)      ((edefp)->tagOmission & OMIT_END_TAG)



/*>sgml_psr.c>*/
/* --- */
/*<spuser.c<*/
extern ConStringT Sgml_GetLcnmstrt FARGS((VoidT));
extern ConStringT Sgml_GetUcnmstrt FARGS((VoidT));
extern ConStringT Sgml_GetLcnmchar FARGS((VoidT));
extern ConStringT Sgml_GetUcnmchar FARGS((VoidT));
extern BoolT Sgml_GetEntityNamecase FARGS((VoidT));
extern BoolT Sgml_GetGeneralNamecase FARGS((VoidT));
extern UIntT Sgml_GetQuantity FARGS((SgmlQuantityTypeT quantity));
extern ConStringT Sgml_GetDelimiterString FARGS((
	SgmlDelimiterTypeT deltype));
extern ConStringT Sgml_GetReservedName FARGS((SgmlReservedNameT rn));
extern IntT Sgml_GetOptionalFeature FARGS((SgmlFeatureTypeT feature));
extern ConStringT Sgml_GetAppinfo FARGS((VoidT));
extern ConStringT Sgml_GetFirstEntityName FARGS((
	SgmlEntityScopeT scope));
extern ConStringT Sgml_GetNextEntityName FARGS((SgmlEntityScopeT scope,
	StringT ename));
extern const SgmlEntityDefT *Sgml_GetEntityDef FARGS((
	SgmlEntityScopeT scope, StringT ename));
extern const SgmlEntityDefT *Sgml_GetDefaultEntityDef FARGS((VoidT));
extern ConStringT Sgml_GetFirstNotationName FARGS((VoidT));
extern ConStringT Sgml_GetNextNotationName FARGS((StringT nname));
extern const SgmlNotationDefT *Sgml_GetNotationDef FARGS((
	StringT nname));
extern ConStringT Sgml_GetDocTypeName FARGS((VoidT));
extern ConStringT Sgml_GetFirstElementName FARGS((VoidT));
extern ConStringT Sgml_GetNextElementName FARGS((StringT etag));
extern const SgmlElementDefT *Sgml_GetElementDef FARGS((StringT etag));
extern VoidT Sgml_GetLoc FARGS((UIntT *linep, FilePathT **fpp));
extern SgmlAttrValT Sgml_CopyAttrVal FARGS((SgmlAttrValT *attrVal));
extern SgmlAttrValsT Sgml_CopyAttrVals FARGS((SgmlAttrValsT *attrVals));
extern VoidT Sgml_DeallocateAttrVal FARGS((SgmlAttrValT *attrVal));
extern VoidT Sgml_DeallocateAttrVals FARGS((SgmlAttrValsT *attrVals));
/*>spuser.c>*/
#ifdef __cplusplus /* end */
}
#endif
#endif /* fm_psr_h */

/* Installed: .\fm_psr.h */
