/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FMEMORY_H
#define FMEMORY_H

#ifdef MACINTOSH
typedef IntT HandleRefT;
#define HandleT HandleRefT
#else
typedef struct _masterHandleT *HandleT;
#endif


#define TOOBIG 100000000L
#define NO_DSE 0 /* return NULL if can't allocate */
#define DSE 1	/* call exit handler set by F_SetDSExit if can't allocate */

/*
 * NB this restriction is no longer enforced; we depend on a large flat
 * address space.
 */
#define PCTOOBIG (64L*1024L)

#ifdef __cplusplus
extern "C" {
#endif

extern HandleT F_AllocHandle FARGS((UIntT size, PUCharT flags));
extern ErrorT F_FreeHandle FARGS((HandleT));
extern ErrorT FdeFreeHandle FARGS((HandleT *));
extern AddrT F_LockHandle FARGS((HandleT handle));
extern IntT F_UnlockHandle FARGS((HandleT handle));
extern HandleT F_ReallocHandle FARGS((HandleT handle, UIntT newSize, PUCharT flags));
extern UIntT F_GetHandleSize FARGS((HandleT handle));
extern BoolT F_HandlesAreEqual FARGS((HandleT handle1, HandleT handle2));
extern BoolT F_HandleEqual FARGS((HandleT handle1, HandleT handle2));
extern BoolT F_DuplicateHandle FARGS((HandleT srcHandle, HandleT dstHandle));
extern ErrorT F_ClearHandle FARGS((HandleT handle));
extern PtrT F_Alloc FARGS((UIntT size, PUCharT flags));
extern PtrT F_Calloc FARGS((UIntT n, UIntT size, PUCharT flags));
extern ErrorT FdeFree FARGS((PtrT *ptr));
extern ErrorT F_Free FARGS((PtrT ptr));
extern BoolT F_PtrEqual FARGS((ConPtrT ptr1, ConPtrT ptr2, UIntT size1));
/*
 * F_BytesEqual withdrawn from the library.  This macro retains
 * source-code compatibility.
 */
#define F_BytesEqual(x, y, n)F_PtrEqual((PtrT) (x), (PtrT) (y), n)
extern PtrT F_DuplicatePtr FARGS((ConPtrT srcPtr, UIntT size, PUCharT flags));
extern ErrorT F_CopyPtr FARGS((ConPtrT srcPtr, PtrT dstPtr, UIntT numBytes));
extern ErrorT F_CopyBytes FARGS((const UCharT *srcPtr, UCharT *dstPtr,
	UIntT numBytes));
extern ErrorT F_ClearPtr FARGS((PtrT ptr, UIntT size));
extern PtrT F_Realloc FARGS((PtrT ptr, UIntT newsize, PUCharT flags));

#ifdef __cplusplus
}
#endif

#endif /* FMEMORY_H */
