/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FMETRICS_H 
#define FMETRICS_H 

/*
 * Basic geometric types: MetricT, PointT, SizeT, RectT.
 * All these types have 4-byte coordinates.
 */

typedef	MetricT	AngleT;

#define FM_EPSILON	((MetricT)0x10)		/* A small non-zero number */

/* Angular measurements */
#define FM_1		((MetricT)0x10000)
#define FM_360		(360*FM_1)

#ifdef  __cplusplus
extern "C" {
#endif

extern MetricT F_MetricFloat FARGS((PRealT f));
extern PRealT F_MetricToFloat FARGS((MetricT m));
extern MetricT F_MetricMake FARGS((IntT n, IntT d));
extern MetricT F_MetricSquare FARGS((MetricT x));
extern MetricT F_MetricSqrt FARGS((MetricT a));
extern MetricT F_MetricMul FARGS((MetricT x, MetricT y));
extern BoolT F_MetricApproxEqual FARGS((MetricT a, MetricT b));
extern MetricT F_MetricDiv FARGS((MetricT sx, MetricT sy));
extern MetricT F_MetricFractMul FARGS((MetricT x, IntT n, IntT d));
extern VoidT F_MetricNormalizeAngle FARGS((AngleT *anglep));
extern VoidT F_MetricConstrainAngle FARGS((AngleT *anglep, AngleT lbound));

#ifdef  __cplusplus
}
#endif

#endif /* FMETRICS_H  */ 
