/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FMIFNAME_H
#define FMIFNAME_H

/* MIFGetString defined for UNIX */
#define MIFGetString(x) ((StringT) (x))        /* unix MifGetString */ 

#define MIFStringID		"String"
#define MIFDMarginsID		"DMargins"
#define MIFDColumnsID		"DColumns"
#define MIFDColumnGapID		"DColumnGap"
#define MIFDPageSizeID		"DPageSize"
#define MIFDStartPageID		"DStartPage"
#define MIFDTwoSidesID		"DTwoSides"
#define MIFDParityID		"DParity"
#define MIFDPageNumStyleID	"DPageNumStyle"
#define MIFDFNotePgfTagID	"DFNotePgfTag"
#define MIFDFNoteMaxHID		"DFNoteMaxH"
#define MIFDFNoteNumStyleID	"DFNoteNumStyle"
#define MIFDFNoteLabelsID	"DFNoteLabels"
#define MIFDFNoteRestartID	"DFNoteRestart"
#define MIFDFNoteNumberPosID	"DFNoteNumberPos"
#define MIFDPageRoundingID	"DPageRounding"
#define MIFDLinebreakCharsID	"DLinebreakChars"
#define MIFPgfTagID		"PgfTag"
#define MIFPgfUseNextTagID	"PgfUseNextTag"
#define MIFPgfNextTagID		"PgfNextTag"
#define MIFPgfLIndentID		"PgfLIndent"
#define MIFPgfFIndentID		"PgfFIndent"
#define MIFPgfRIndentID		"PgfRIndent"
#define MIFPgfAlignmentID	"PgfAlignment"
#define MIFPgfTopSeparatorID	"PgfTopSeparator"
#define MIFPgfBotSeparatorID	"PgfBotSeparator"
#define MIFPgfPlacementID	"PgfPlacement"
#define MIFPgfSpBeforeID	"PgfSpBefore"
#define MIFPgfSpAfterID		"PgfSpAfter"
#define MIFPgfWithNextID	"PgfWithNext"
#define MIFPgfBlockSizeID	"PgfBlockSize"
#define MIFPgfAutoNumID		"PgfAutoNum"
#define MIFPgfNumberFontID	"PgfNumberFont"
#define MIFPgfNumFormatID	"PgfNumFormat"
#define MIFPgfNumStringID	"PgfNumString"
#define MIFPgfLineSpacingID	"PgfLineSpacing"
#define MIFPgfLeadingID		"PgfLeading"
#define MIFPgfNumTabsID		"PgfNumTabs"
#define MIFTSXID		"TSX"
#define MIFTSTypeID		"TSType"
#define MIFTSLeaderStrID		"TSLeaderStr"
#define MIFTSDecimalCharID	"TSDecimalChar"
#define MIFPgfHyphenateID	"PgfHyphenate"
#define MIFHyphenMaxLinesID	"HyphenMaxLines"
#define MIFHyphenMinPrefixID	"HyphenMinPrefix"
#define MIFHyphenMinSuffixID	"HyphenMinSuffix"
#define MIFHyphenMinWordID	"HyphenMinWord"
#define MIFHyphenQualityID	"HyphenQuality"
#define MIFPgfLetterSpaceID	"PgfLetterSpace"
#define MIFPgfMinWordSpaceID	"PgfMinWordSpace"
#define MIFPgfOptWordSpaceID	"PgfOptWordSpace"
#define MIFPgfMaxWordSpaceID	"PgfMaxWordSpace"
#define MIFPgfLanguageID	"PgfLanguage"
#define MIFPgfCellAlignmentID	"PgfCellAlignment"
#define MIFPgfCellMarginsID	"PgfCellMargins"
#define MIFFTagID		"FTag"
#define MIFFFamilyID		"FFamily"
#define MIFFVarID		"FVar"
#define MIFFWeightID		"FWeight"
#define MIFFAngleID		"FAngle"
#define MIFFSizeID		"FSize"
#define MIFFUnderlineID		"FUnderline"
#define MIFFDoubleUnderlineID		"FDoubleUnderline"
#define MIFFStrikeID		"FStrike"
#define MIFFSupScriptID		"FSupScript"
#define MIFFSubScriptID		"FSubScript"
#define MIFFSmallCapsID		"FSmallCaps"
#define MIFFCapsID		"FCaps"
#define MIFFChangeBarID		"FChangeBar"
#define MIFFOutlineID		"FOutline"
#define MIFFShadowID		"FShadow"
#define MIFFPairKernID		"FPairKern"
#define MIFFPlainID		"FPlain"
#define MIFFBoldID		"FBold"
#define MIFFItalicID		"FItalic"
#define MIFFDXID		"FDX"
#define MIFFDYID		"FDY"
#define MIFFDWID		"FDW"
#define MIFFLockedID		"FLocked"
#define MIFFSeparationID	"FSeparation"
#define MIFFlipLRID		"FlipLR"
#define MIFPenID		"Pen"
#define MIFFillID		"Fill"
#define MIFPenWidthID		"PenWidth"
#define MIFSeparationID		"Separation"
#define MIFAngleID		"Angle"
#define MIFBRectID		"BRect"
#define MIFTextFlowID		"TextFlow"
#define MIFTFTagID		"TFTag"
#define MIFTFAutoConnectID	"TFAutoConnect"
#define MIFTextRectIDID		"TextRectID"
#define MIFIDID			"ID"
#define MIFPageSizeID		"PageSize"
#define MIFPageTypeID		"PageType"
#define MIFPageTagID		"PageTag"
#define MIFPageOrientationID	"PageOrientation"
#define MIFPageNumID		"PageNum"
#define MIFPageBackgroundID	"PageBackground"
#define MIFTagID		"Tag"
#define MIFFrameTypeID		"FrameType"
#define MIFPolyLineID		"PolyLine"
#define MIFNumPointsID		"NumPoints"
#define MIFPointID		"Point"
#define MIFTextLineID		"TextLine"
#define MIFTLOriginID		"TLOrigin"
#define MIFTLAlignmentID	"TLAlignment"
#define MIFCharID		"Char"
#define MIFVariableID		"Variable"
#define MIFVariableNameID	"VariableName"
#define MIFUnitsID		"Units"
#define MIFLeftID		"Left"
#define MIFUnknownID		"Unknown"
#define MIFVerboseID		"Verbose"
#define MIFYesID		"Yes"
#define MIFNoID		"No"
#define MIFSmoothedID		"Smoothed"

#endif /* FMIFNAME_H */ 
