/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FPATH_H
#define FPATH_H

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
	FDefaultPath,
	FDIPath,
	FUnixPath,
	FMacPath,
	FDosPath
} PathEnumT;

#ifndef FILEPATH_DEFINED
#define FILEPATH_DEFINED
#define _FilePathT FilePathT
typedef struct _FilePathT FilePathT;
#endif

#ifdef __cplusplus
}
#endif

/*
 * Flags to F_FilePathProperty.
 */
#define FF_FilePathReadable   0x0001
#define FF_FilePathWritable   0x0002
#define FF_FilePathDirectory  0x0100
#define FF_FilePathFile       0x0200
#define FF_FilePathExist      0x0400

#define FF_FilePathStat \
(FF_FilePathDirectory|FF_FilePathFile|FF_FilePathExist)
#define FF_FilePathAccess \
(FF_FilePathReadable|FF_FilePathWritable)

#endif /* FPATH_H */
