/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FSTRLIST_H
#define FSTRLIST_H 

#ifdef  __cplusplus
extern "C" {
#endif

extern StringListT F_StrListNew FARGS((UIntT numStrings, UIntT quantum));
extern VoidT FdeFreeStrList FARGS((StringListT *list));
extern VoidT F_StrListFree FARGS((StringListT list));
extern ErrorT F_StrListAppend FARGS((StringListT list, ConStringT string));
extern ErrorT F_StrListInsert FARGS((StringListT list, ConStringT string, IntT position));
extern ErrorT F_StrListSetString FARGS((StringListT list, ConStringT string, IntT position));
extern VoidT F_StrListRemove FARGS((StringListT list, IntT position));
extern IntT F_StrListIndex FARGS((StringListT list, ConStringT string));
extern IntT F_StrListIIndex FARGS((StringListT list, ConStringT string));
extern ErrorT F_StrListCat FARGS((StringListT toList, StringListT appendList));
extern IntT F_StrListLen FARGS((StringListT list));
extern StringT *F_StrListStrings FARGS((StringListT list));
extern IntT F_StrListCopy FARGS((StringListT strlist, IntT n, StringT strbuf, UIntT size));
extern StringT F_StrListGet FARGS((StringListT strlist, IntT n));
extern VoidT F_StrListSort FARGS((StringListT strlist,
	NativeIntT (*fn)(ConStringT, ConStringT)));
extern StringListT F_StrListCopyList FARGS((StringListT strlist));

#ifdef  __cplusplus
}
#endif

#define F_StrListFirst(list) F_StrListGet(list, 0)
#define F_StrListLast(list) F_StrListGet(list, F_StrListLen(list)-1)

#endif /* FSTRLIST_H */ 
