/*
 * COPYRIGHT (c) 1986-1996 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FSTRRES_H
#define FSTRRES_H

#ifdef __cplusplus
extern "C" {
#endif

extern ErrorT F_SrInit FARGS((const UCharT *appname, const UCharT *uilanguage));
extern StringT F_SrCopy FARGS((IntT srindex));
extern ErrorT F_SrGetN FARGS((IntT srindex, UCharT *buf, UIntT n));
extern ErrorT F_SrGetF FARGS((IntT srindex, UCharT *buf, UIntT n,
	const UCharT *argformat, ...));
#ifdef va_arg
/*
 * To use this declaration, you need to #include either <stdarg.h> or
 * <varargs.h>, depending on your C implementation.  See the discussion
 * of USE_STDARG in "f_types.h".
 */
extern ErrorT F_SrGetVF FARGS((IntT srindex, UCharT *buf, UIntT n,
	const UCharT *argformat, va_list argsp));
#endif

#ifdef __cplusplus
}
#endif

#endif /* FSTRRES_H */
