/*
 * COPYRIGHT (c) 1986-1998 Adobe Systems Incorporated.
 *
 * This source code contained herein is proprietary and
 * confidential information of Adobe Systems Incorporated
 * and is covered by the U.S. and other copyright and trade
 * secret protection.  Unauthorized adaptation, distribution,
 * use or display is prohibited and may be subject to civil
 * and criminal penalties.  Disclosure to others is prohibited.
 * For the terms and conditions of source code use refer to
 * your Adobe Systems Incorporated Source Code License Agreement.
 */

#ifndef FTRANS_H
#define FTRANS_H

#ifdef  __cplusplus
extern "C" {
#endif
extern VoidT F_ApiTransCreateHistory(GenericT key, IntT foreignWnd, IntT maxEntries);
extern VoidT F_ApiTransClearAll(GenericT key);
extern VoidT F_ApiTransDeleteHistory(GenericT key);
extern VoidT F_ApiTransCheckpoint(GenericT key, F_ObjHandleT docId, ConStringT description);
extern F_ObjHandleT F_ApiTransCancelCheckpoint(GenericT key);
extern VoidT F_ApiTransSaveSelection(GenericT key, F_ObjHandleT docId);
extern F_ObjHandleT F_ApiTransUndo(GenericT key, F_ObjHandleT docId, IntT count);
extern F_ObjHandleT F_ApiTransRedo(GenericT key, F_ObjHandleT docId, IntT count);
extern IntT F_ApiTransUndoCount(GenericT key);
extern IntT F_ApiTransRedoCount(GenericT key);
extern ConStringT F_ApiTransGetUndoDescription(GenericT key, IntT transIndex);
extern ConStringT F_ApiTransGetRedoDescription(GenericT key, IntT transIndex);

#ifdef  __cplusplus
}
#endif

#define	UNDO_UNDEF			0x00

#define UNDO_NewFrameMakerObject		0x01
#define UNDO_OBJ_ATT        0x02

#define UNDO_MOVE			0x05
#define UNDO_RESIZE			0x06
#define UNDO_RESHAPE		0x07
#define UNDO_GFXQUICKCOPY	0x08
#define UNDO_ADDVERTEX		0x09
#define UNDO_DELETEVERTEX	0x0A

#define UNDO_FRONT			0x10
#define UNDO_BACK			0x11
#define UNDO_GROUP			0x12
#define UNDO_UNGROUP		0x13
#define UNDO_RESHAPEHANDLES	0x14
#define UNDO_PLAT_UNGROUP	0x16
#define UNDO_SCALE			0x18
#define UNDO_ALIGN			0x19
#define UNDO_DISTRIBUTE		0x1A
#define UNDO_SETNUMSIDES	0x1B
#define UNDO_OBJPROPS		0x1C
#define UNDO_JOINCURVES		0x1D

#define UNDO_GRID			0x20
#define UNDO_SNAP			0x21
#define UNDO_RULERS			0x22
#define UNDO_BORDERS		0x23
#define UNDO_SYMBOLS		0x24
#define UNDO_SCALES			0x25
#define UNDO_GRAVITY		0x26
#define UNDO_KEEPTOOL		0x27
#define UNDO_CONSTRAIN		0x28
#define UNDO_ZOOM           0x29
#define UNDO_ELEM_BORDERS   0x2A
#define UNDO_FULLRULERS		0x2B
#define UNDO_LINK_BOUNDARIES   0x2C

#define UNDO_CONNECT		0x30
#define UNDO_CUTHEAD		0x31
#define UNDO_CUTTAIL		0x32
#define UNDO_SPLIT			0x33
#define UNDO_FLOWPROPS		0x34
#define UNDO_SIDEHEADLAYOUT	0x35

#define UNDO_TABS			0x40
#define UNDO_EQUATIONPREFERENCES 0x41
#define UNDO_PGFPROPS		0x42
#define UNDO_COLUMNS		0x46
#define UNDO_HEADERS		0x47
#define UNDO_FONTPROPS		0x48
#define UNDO_CHANGEBARS		0x49

#define UNDO_TEXTCUT		0x50
#define UNDO_GFXCUT			0x51
#define UNDO_COPY			0x52
#define UNDO_TEXTPASTE		0x53
#define UNDO_GFXPASTE		0x54
#define UNDO_STUFF			0x55
#define UNDO_ANCHOR			0x56
#define UNDO_REPLACE		0x57
#define UNDO_MARKER			0x58
#define UNDO_CAPITAL		0x59
#define UNDO_CORRECT		0x5A
#define UNDO_UNSHRINKWRAP	0x5B

#define UNDO_TYPING			0x60
#define UNDO_DELCHAR		0x61
#define UNDO_XCHARS			0x62
#define UNDO_FLIPLR			0x63
#define UNDO_FLIPUD			0x64
#define UNDO_ROTATE			0x65
#define UNDO_SMOOTH         0x66
#define UNDO_UNSMOOTH       0x67

#define UNDO_FNOTE          0x70
#define UNDO_FNOTEPROPS		0x71
#define UNDO_ROTPAGE		0x72
#define UNDO_CONDPROPS		0x73
#define UNDO_CONDVIS		0x74
#define UNDO_CONDEDIT		0x75
#define UNDO_TABLES			0x76
#define UNDO_TBLCONVERT		0x77
#define UNDO_ELEMENT_DRAG	0x78
#define	UNDO_GLINE_ATT		0x79
#define UNDO_COLLAPSE		0x80
#define UNDO_ATTRIBUTES		0x81
#define UNDO_RUBIPROPS		0x82

#define UNDO_MATHEDIT		0x90
#define UNDO_CREATE_PUBLISHER 0x91 /* Mac only */
#define UNDO_SUBSCRIBE_TO	0x92   /* Mac only */
#define UNDO_PUB_SUB_OPTS	0x93   /* Mac only */
#define UNDO_DOCCLOSE		0xA0   /* Mac only */
#define UNDO_CANCEL         0xA1   /* Operation failed.*/
#endif /* FTRANS_H */
