/****************************************************************

 *	Usage:	Tempnam(char *temppath);  where temppath >= 22 chrs

 *

 *	Routine that generates a generic temp name that will work

 *	on UNIX and Windows.  It generates a name of the format:

 *	"oleXXXXX.OOO" where the X'x are the last 5 digits of the

 *	process id, and the O's each represent a letter from a to z.

 *	For example, if the pid is 187, the first temp file name

 *	will be "ole00187.aaa".

 ***************************************************************/



# include <stdio.h>

# include <stdlib.h>

# include <string.h>

# include <io.h>

# include "Tempnam.h"



#if !defined(UNIXWARE) || !defined(sparc)

extern "C" {

int	getpid(void);

}

#endif



static char c1='a';

static char c2='a';

static char c3='a';



static char *tfstack[200];

static int  tfstackptr = 0;



char* Tempnam(char *tname)

{

	char buf[50];

	getNewName(buf);

	while (access(buf, 0) != -1)

	{

		getNewName(buf);

	}



	strcpy(tname, buf);

	return (tname);

}



void getNewName(char* buf)

{

	char tname[50];

	char *s;

	strcpy(tname, "oleXXXXX.OOO");



	register unsigned pid = getpid();

	s = tname+8;

	while(*--s == 'X')

	{

		*s = (pid%10) + '0';

		pid /= 10;

	}



	/*

	**	Splice in the 3 new letters.

	*/

	s = tname+9;

	*s = c1;

	*(s+1) = c2;

	*(s+2) = c3++;



	/*

	**	Now increment the group of 3 letters for

	**	next time.

	*/

	if(c3 > 'z')

	{

		c3 = 'a';

		if(++c2 > 'z')

		{

			c2 = 'a';

			if(++c1 > 'z')

				c1 = 'a';

		}

	}

	char* t = getenv("TEMP");

	if (t == NULL || *t == '\0')

	{

		strcpy(buf, "D:\\temp\\");

	}

	else

	{

		strcpy(buf, t);

		strcat(buf, "\\");

	}

	strcat(buf, tname);

}

