
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdarg.h>

void	debuglog(char*, ...);
char*	ermsg = "c:\\olesrvr\\errormsg";
char*	msgt1 = "c:\\olesrvr\\MsgT1";
char*	msgt2 = "c:\\olesrvr\\MsgT2";
char*	msge1 = "c:\\olesrvr\\MsgE1";
char*	msge2 = "c:\\olesrvr\\MsgE2";

void errormsg(char* fmt, ...)
{
	FILE	*fp;
	char	fmtemp[600];
	va_list	argptr;

	if((fp = fopen(ermsg, "a+")) == NULL)
	{
		debuglog("Can't open %s file for writing error.\n", ermsg);
		return;
	}

	va_start(argptr, fmt);
	vsprintf(fmtemp, fmt, argptr);
	va_end(argptr);
	fprintf(fp, "%s", fmtemp);

	fflush(fp);
	fclose(fp);
}

int getErrorMsg(char *message)
{
	FILE	*fp;
	char	buf[BUFSIZ+1];
	int	n;

	if((fp = fopen(ermsg, "r")) == NULL)
	{
		debuglog("getErrorMsg: No %s file.\n", ermsg);
		return -1;
	}

	strcpy(message, "");
	while((n=fread(buf, sizeof(char), BUFSIZ, fp)) > 0)
	{
		strcat(message, buf);
	}

	fclose(fp);
	unlink(ermsg);
	return 0;
}

int makeErrorFile(char* message)
{
	int	n;
	FILE	*to, *from;
	char	buf[BUFSIZ+1];
	char	*rmode = "r+b";
	char	*wmode = "w+b";

        if((from = fopen(msgt1, rmode)) == NULL)
	{
		debuglog("makeErrorFile: can't open %s\n", msgt1);
		errormsg("makeErrorFile: can't open %s\n", msgt1);
		return 1;
	}

	if((to = fopen(msge1, wmode))==NULL) 
	{
		debuglog("makeErrorFile: can't open %s\n", msge1);
		errormsg("makeErrorFile: can't open %s\n", msge1);
		fclose(from);
		return 1;
	}

	while((n=fread(buf, sizeof(char), BUFSIZ, from)) > 0)
	{
		fwrite(buf, sizeof(char), n, to);
	}

	fwrite(message, sizeof(char), strlen(message), to);

	fflush(to);
	fclose(to);
	fclose(from);

	return 0;
}
int makeError2File(char* message)
{
	int	n;
	FILE	*to, *from;
	char	buf[BUFSIZ+1];
	char	*rmode = "r+b";
	char	*wmode = "w+b";

        if((from = fopen(msgt2, rmode)) == NULL)
	{
		debuglog("makeErrorFile: can't open %s\n", msgt2);
		errormsg("makeErrorFile: can't open %s\n", msgt2);
		return 1;
	}

	if((to = fopen(msge2, wmode))==NULL) 
	{
		debuglog("makeErrorFile: can't open %s\n", msge2);
		errormsg("makeErrorFile: can't open %s\n", msge2);
		fclose(from);
		return 1;
	}

	while((n=fread(buf, sizeof(char), BUFSIZ, from)) > 0)
	{
		fwrite(buf, sizeof(char), n, to);
	}

	fwrite(message, sizeof(char), strlen(message), to);

	fflush(to);
	fclose(to);
	fclose(from);

	return 0;
}
