
#define DONT_REDEFINE

#include <io.h>
#include <direct.h>
#include "fdetypes.h"
#include "fapi.h"
#include "fstrings.h"
#include "futils.h"
#include "debuglog.h"

int	removeFrameDir(FilePathT*);
int	copyFile(char*, char*);
void	endSession(int, F_ObjHandleT);

int frame2ps(char* ftype, char* msfile)
{
	F_ObjHandleT docId;
	DirHandleT handle;
	IntT statusp;
	FilePathT *fmdir;
	char theFile[200];

	char *FmDir = "c:\\temp\\fmdir";
	char *t = getenv("TEMP");
	if (t != NULL)
	{
		strcpy(FmDir, t);
		strcat(FmDir, "\\fmdir");
	}

	int fmbook = 0;
	if (strcmp(ftype, "frame_book") == 0)
	{
		fmbook = 1;
	}

	/*
	**	Start the FrameMaker process.
	*/
	ConStringT s = F_ApiStartUp(NULL);
	if (s)
	{
		F_ApiErr(s);
		debuglog("Couldn't start up FrameMaker.\n");
		errormsg("Couldn't start up FrameMaker.");
		return 1;
	}

	/*
	**	Create a temp dir (d:\temp\fmdir) and
	**	Move the file/book into a temp directory.
	*/
	fmdir = F_PathNameToFilePath((StringT)FmDir, NULL, FDefaultPath);
	if (!fmdir)
	{
		debuglog("Can't get frame temp directory path.\n");
		errormsg("Can't get frame temp directory path.");
		return 1;
	}

	if (_access(FmDir, 00) == 0)
	{
		removeFrameDir(fmdir);
	}

	if (F_MakeDir(fmdir) != FdeSuccess)
	{
		debuglog("Can't create temp directory for Frame docs.\n");
		errormsg("Can't create temp directory for Frame docs.");
		F_FilePathFree(fmdir);
		return 1;
	}

	//F_ApiSetClientDir(FmDir);  // Unix only

	strcpy(theFile, FmDir);
	strcat(theFile, "\\fm.fm");
	if (fmbook)
	{
		strcpy(theFile, FmDir);
		strcat(theFile, "\\fm.zip");
	}

	if (copyFile(msfile, theFile) != 0)
	{
		removeFrameDir(fmdir);
		return 1;
	}

	if (fmbook)
	{
		/*
		**	Unzip the book.
		*/
		char cmd[200];
		strcpy(cmd, "unzip -qq ");
		strcat(cmd, FmDir);
		strcat(cmd, "\\fm.zip ");
		strcat(cmd, "-d ");
		strcat(cmd, FmDir);
		system(cmd);

		/*
		**	Open the frame temp directory.
		*/
		FilePathT *file;
		StringT basename;

		handle = F_FilePathOpenDir(fmdir, &statusp);
		if (handle == 0)
		{
			debuglog("Can't open Temp Frame directory.\n");
			errormsg("Can't open Temp Frame directory.");
			removeFrameDir(fmdir);
			F_FilePathFree(fmdir);
			return 1;
		}

		/*
		**	Search for a file with "boo" suffix.
		*/
		int gotBook = 0;
		while ((file = F_FilePathGetNext(handle, &statusp)) != NULL)
		{
			basename = F_FilePathBaseName(file);
			//  is this the book?
			char *p = strrchr((char*)basename, '.');
			if (p != NULL) 
			{
				p++;
				if (strncmp(p, "boo", 3) == 0)
				{
					gotBook = 1;
					strcpy(theFile, 
						(char*)F_FilePathToPathName(
						file, FDefaultPath));
					break;
				}
			}
			F_Free(basename);
			F_FilePathFree(file);
		}

		/*
		**	Close the directory.
		*/
		F_FilePathCloseDir(handle);

		/*
		**	Make sure we have a book file
		*/
		if (!gotBook)
		{
			debuglog("No *.boo* file in Frame book.\n");
			errormsg("No *.boo* file in Frame book.");
			removeFrameDir(fmdir);
			F_FilePathFree(fmdir);
			return 1;
		}
	}

	/*
	**	Get the default property list for Open
	**	and change some of the properties.
	*/
	F_PropValsT params;
	F_PropValsT *returnParamsp = NULL;
	IntT Pindex;
	params = F_ApiGetOpenDefaultParams();
	if (params.len == 0)
	{
		debuglog("Couldn't get Open params.\n");
		errormsg("Couldn't get Open params.");
		removeFrameDir(fmdir);
		return 1;
	}

	Pindex = F_ApiGetPropIndex(&params, FS_OpenDocViewOnly);
	if (!fmbook)
	{
		params.val[Pindex].propVal.u.ival = True;
	}
	else
	{
		// for some reason, can't open book as read-only.
		params.val[Pindex].propVal.u.ival = False;
	}
	Pindex = F_ApiGetPropIndex(&params, FS_FontNotFoundInDoc);
	params.val[Pindex].propVal.u.ival = FV_DoOK;

	Pindex = F_ApiGetPropIndex(&params, FS_FileIsOldVersion);
	params.val[Pindex].propVal.u.ival = FV_DoOK;

	Pindex = F_ApiGetPropIndex(&params, FS_BookIsInUse);
	params.val[Pindex].propVal.u.ival = FV_ResetLockAndContinue;

	Pindex = F_ApiGetPropIndex(&params, FS_FileIsInUse);
	params.val[Pindex].propVal.u.ival = FV_ResetLockAndContinue;

	Pindex = F_ApiGetPropIndex(&params, FS_AlertUserAboutFailure);
	params.val[Pindex].propVal.u.ival = False;

	Pindex = F_ApiGetPropIndex(&params, FS_MakeVisible);
	params.val[Pindex].propVal.u.ival = False;

	/*
	**	Open the book or document.
	*/
	docId = F_ApiOpen((StringT)theFile, &params, &returnParamsp);
	if (!docId)
	{
		debuglog("Couldn't open the document %s in Frame.\n",
			theFile);
		errormsg("Couldn't open the document %s in Frame.", theFile);
		removeFrameDir(fmdir);
		return 1;
	}

	//chdir(FmDir);
	if (fmbook)
	{
		/*
		**	Open all the book files which verifies that
		**	all are present and converted properly.
		*/
		StringT compName;
		F_ObjHandleT compId, dId, condObj;

		// reset
		Pindex = F_ApiGetPropIndex(&params, FS_OpenDocViewOnly);
		params.val[Pindex].propVal.u.ival = True;

		compId = F_ApiGetId(FV_SessionId, docId, 
			FP_FirstComponentInBook);
		while (compId)
		{
			compName = F_ApiGetString(docId, compId, FP_Name);
			returnParamsp = NULL;
			dId = F_ApiOpen((StringT)compName, &params, 
				&returnParamsp);
			if (!dId)
			{
				removeFrameDir(fmdir);
				endSession(fmbook, docId);
				debuglog("Can't open frame book file %s.\n",
					compName);
				errormsg("Can't open frame book file %s.",
					compName);
				return 1;
			}

			// set doc properties
			F_ApiSetInt(FV_SessionId, dId, FP_ShowAll, False);
			F_ApiSetInt(FV_SessionId, dId, FP_ShowCondIndicators, 
				False);

			// turn off condition format properties
			condObj = F_ApiGetId(FV_SessionId, dId, 
				FP_FirstCondFmtInDoc);
			while (condObj)
			{
				F_ApiSetInt(dId, condObj, 
					FP_CondFmtIsShown, False);
				F_ApiSetInt(dId, condObj, 
					FP_UseSepOverride, False);
				condObj = F_ApiGetId(dId, condObj, 
					FP_NextCondFmtInDoc);
			}

			// turn off color consistency check 
			condObj = F_ApiGetId(FV_SessionId, dId, 
				FP_FirstColorInDoc);
			while (condObj)
			{
				//F_ApiSetInt(dId, condObj, 
				//	FP_ColorOverprint, FV_COLOR_KNOCKOUT);
				//F_ApiSetInt(dId, condObj, 
				//	FP_ColorPrintCtl, FV_PRINT_NO);
				F_ApiSetInt(dId, condObj, 
					FP_ColorPrintCtl, FV_PRINT_PROCESS);

				condObj = F_ApiGetId(dId, condObj, 
					FP_NextColorInDoc);
			}

			F_ApiClearAllChangebars(dId);
			F_Free(compName);
			compId = F_ApiGetId(docId, compId, 
				FP_NextComponentInBook);
		}
	}
	F_ApiDeallocatePropVals(&params);
	F_ApiDeallocatePropVals(returnParamsp);

	/*
	**	Print it:  We set printToFile so that all book files
	**	print instead of just the last file like MS excel.
	F_ApiSetInt(FV_SessionId, docId, FP_GenerateAcrobatInfo, True);
	*/
	F_ApiSetInt(FV_SessionId, docId, FP_PrintScope, FV_PR_ALL);
	F_ApiSetInt(FV_SessionId, docId, FP_PrintToFile, True);
	F_ApiSetInt(FV_SessionId, docId, FP_PrintSeps, False);
	F_ApiSetInt(FV_SessionId, docId, FP_PrintLastSheetFirst, False);
	F_ApiSetString(FV_SessionId, docId, FP_PrintFileName, 
		(StringT)"c:\\distOut.ps");
	if (F_ApiSilentPrintDoc(docId) != FE_Success)
	{
		debuglog("Some error printing the frame document.\n");
		errormsg("Got Some error printing the frame document.");
	}

	endSession(fmbook, docId);
	removeFrameDir(fmdir);
	F_FilePathFree(fmdir);
	return 0;
}

void endSession(int fmbook, F_ObjHandleT docId)
{
	/*
	**	End the session with FrameMaker
	*/
	if (fmbook)
	{
		/*
		**	Close all the book files.
		*/
		F_ObjHandleT compId;

		compId = F_ApiGetId(FV_SessionId, docId, 
			FP_FirstComponentInBook);
		while (compId)
		{
			F_ApiClose(compId, FF_CLOSE_MODIFIED);
			compId = F_ApiGetId(docId, compId, 
				FP_NextComponentInBook);
		}
	}
	F_ApiClose(docId, FF_CLOSE_MODIFIED);
	F_ApiClose(FV_SessionId, FF_CLOSE_MODIFIED);
}

int removeFrameDir(FilePathT *fmdir)
{
	DirHandleT handle;
	IntT statusp;

	/*
	**	Remove the frame directory and all the files.
	*/
	handle = F_FilePathOpenDir(fmdir, &statusp);
	if (handle == 0)
	{
		debuglog("Temp frame directory can't be opened.\n");
		errormsg("Temp frame directory can't be opened.");
		F_FilePathFree(fmdir);
		return 1;
	}

	/*
	**	Remove each file in temp frame directory.
	*/
	FilePathT *file;
	while ((file = F_FilePathGetNext(handle, &statusp)) != NULL)
	{
		F_DeleteFile(file);
		F_FilePathFree(file);
	}
	F_FilePathCloseDir(handle);
	F_DeleteFile(fmdir);

	return 0;
}

int copyFile(char* from_path, char* to_path)
{
	int	n;
	FILE	*to, *from;
	char	buf[BUFSIZ+1];
	char	*rmode = "r+b";
	char	*wmode = "w+b";

        if((from = fopen(from_path, rmode)) == NULL)
	{
		debuglog("copyFile: can't open %s\n", from_path);
		errormsg("copyFile: can't open %s.", from_path);
		return 1;
	}

	if((to = fopen(to_path, wmode))==NULL) 
	{
		debuglog("copyFile: can't open %s\n", to_path);
		errormsg("copyFile: can't open %s.", to_path);
		fclose(from);
		return 1;
	}

	while((n=fread(buf, sizeof(char), BUFSIZ, from)) > 0)
	{
		fwrite(buf, sizeof(char), n, to);
	}

	fclose(to);
	fclose(from);

	return 0;
}
