

#include <stdio.h>

#include <stdlib.h>

#include <string.h>

#include <io.h>

#include <time.h>

#include <sys/types.h>

#include <sys/stat.h>

#include "debuglog.h"



char*	lock_file = "C:\\LOCKFILE";

void unlock(void);



char *getTime()

{

	/*

	**	Get the time stamp

	*/

	long tm = time((long *) 0);

	char *tmstr = ctime(&tm);

	tmstr[strlen(tmstr)-1] = '\0';

	return (tmstr);

}



/*

**	Check to see if the lock file is there.  If not, create it.

**	If there, unlock it if it has been there 3 hours.

**	Return 1 if we got the lock file.

*/

int lock()

{

	int	f;

	time_t	modtime;

	long	nowtime;

	struct	_stat	statbuf;



	/*

	**	If lock file does not exist, create it and return

	*/

	f = _creat(lock_file, 0);

	if (f >= 0) 

	{

		_close(f);

		return(1);

	}



	/*

	**	Lock file already exists.  See if it has been out there 

	**	for an hour or more.  If so, assume that you can have it 

	**	and other process using it has died and gone to hell.

	*/

	nowtime = time((long *) 0);

	_stat(lock_file, &statbuf);

	modtime = statbuf.st_mtime;

	if( (nowtime-modtime)/900 >= 1)  // 15 minutes

	{

		unlock();

		f = _creat(lock_file, 0);

		if (f >= 0)

		{

			debuglog("%s: ** Had to remove lock file!\n", 

				getTime());

			_close(f);

			return(1);

		}

		else

		{

			debuglog("%s: *** Couldn't remove lock file!\n",

			     getTime());

			return(0);

		}

    	}

	else

	{

    		return(0);

	}

}



/*	attempts to unlock file; returns 1 if successful,

**	0 if not

*/

void unlock()

{

	_chmod(lock_file, _S_IREAD | _S_IWRITE);

    	_unlink(lock_file);

    	return;

}

