VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ms2pdf"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Sub diffdocs(ByVal msFile1 As String, _
        ByVal msFile2 As String, ByVal pdfFile As String)

    On Error GoTo CheckError
    Err.Clear
    
    Dim appWD As Object
    Dim appDoc As Object

    Set appWD = CreateObject("Word.Application")
    Set appDoc = appWD.Documents.Open(msFile1, True, False, False)
    
    appDoc.Compare Name:=msFile2, DetectFormatChanges:=False, _
        IgnoreAllComparisonWarnings:=True, _
        CompareTarget:=wdCompareTargetCurrent
         
    appDoc.PrintOut Background:=False, Copies:=1
        
    appDoc.Close SaveChanges:=wdDoNotSaveChanges
    
    appWD.Quit
    Set appWD = Nothing
    
    distillIt (pdfFile)

    Exit Sub
    
CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        appWD.Quit
        Set appWD = Nothing
        Exit Sub
    End If
    
End Sub

        

Public Sub visio2ps(ByVal msFile As String, _
        ByVal pdfFile As String)

    On Error GoTo CheckError
    Err.Clear

    Dim appVS As Object
    Set appVS = CreateObject("Visio.Application")

    With appVS.Documents
        .Open FileName:=msFile
        
        With appVS.ActiveDocument
            .Print
        End With
        
    End With

    appVS.Quit
    Set appVS = Nothing
    
    distillIt (pdfFile)

    Exit Sub
CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        appVS.Quit
        Set appVS = Nothing
        Exit Sub
    End If

End Sub

Public Sub word2ps(ByVal msFile As String, _
        ByVal pdfFile As String)
    
    On Error GoTo CheckError
    Err.Clear
    
    Dim appWD As Object
    Set appWD = CreateObject("Word.Application")
'   appWD.Visible = True
'   appWD.ActivePrinter = _
'       "HP LaserJet IIIP PostScript Cartridge v52.2"

    With appWD.Documents
        .Open FileName:=msFile, ReadOnly:=True, _
            ConfirmConversions:=False, AddToRecentFiles:=False

        With appWD.ActiveDocument
            .PrintOut Background:=False, Copies:=1
        End With
    
        .Close SaveChanges:=wdDoNotSaveChanges
    End With

    appWD.Quit
    Set appWD = Nothing
    
    distillIt (pdfFile)

    Exit Sub
    
CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        appWD.Quit
        Set appWD = Nothing
        Exit Sub
    End If

End Sub

Public Sub pwpt2ps(ByVal msFile As String, _
        ByVal pdfFile As String)
    
    On Error GoTo CheckError
    Err.Clear
    
    Dim ppt As Object
    
    '
    '   This is supposed to get a new object even
    '   if PowerPoint is running but can't make
    '   that work yet.  I even tried GetObject().
    '   We get Error 429 if ppt already running.
    '
    Set ppt = CreateObject("PowerPoint.Application")
    
    '
    '   If we don't set PowerPoint visible then we
    '   will get an error message that the window
    '   frame does not exist trying to open a file.
    '
    ppt.Visible = True
    ppt.WindowState = ppWindowMinimized

    With ppt.Presentations
        '
        '    Open the file as read-only.
        '
        .Open FileName:=msFile, ReadOnly:=True
    
        '
        '    Print the file in forground because
        '    we must wait for print to finish
        '    before returning from this OLE DLL.
        '
        With ppt.ActivePresentation
            With .PrintOptions
                .PrintInBackground = False
            End With
        .PrintOut Copies:=1
        End With

    End With
    
    ppt.Quit
    Set ppt = Nothing
    
    distillIt (pdfFile)

    Exit Sub

CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        ppt.Quit
        Set ppt = Nothing
        Exit Sub
    End If
End Sub

Public Sub proj2ps(ByVal msFile As String, _
        ByVal pdfFile As String)
    
    On Error GoTo CheckError
    Err.Clear
    
    Dim myProj As Object
    Set myProj = CreateObject("MSProject.Application")
    myProj.Visible = True
    AppActivate "Microsoft Project"
    myProj.FileOpen Name:=msFile, ReadOnly:=True
    myProj.FilePrint PageBreaks:=True, Copies:=1, _
        Draft:=False, OnePageWide:=False, _
        Preview:=False, Color:=True
    myProj.FileClose (PjSaveType.pjDoNotSave)
    myProj.Quit
    Set myProj = Nothing
    
    distillIt (pdfFile)
    Exit Sub

CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        myProj.Quit
        Set myProj = Nothing
        Exit Sub
    End If
End Sub

Public Sub excl2ps(ByVal msFile As String, _
        ByVal pdfFile As String)
    
    On Error GoTo CheckError
    Err.Clear
    
    Dim myBook As Object
    Set myBook = CreateObject("Excel.Application")
    myBook.Workbooks.Open FileName:=msFile, UpdateLinks:=0, _
        ReadOnly:=True, IgnoreReadOnlyRecommended:=True
    
    With myBook.ActiveWorkbook
        .PrintOut
        .Close SaveChanges:=False
    End With

    myBook.Quit
    Set myBook = Nothing
    
    distillIt (pdfFile)
    Exit Sub

CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        myBook.ActiveWorkbook.Close SaveChanges:=False
        myBook.Quit
        Set myBook = Nothing
        Exit Sub
    End If
End Sub

Public Sub binder2ps(ByVal msFile As String, _
        ByVal pdfFile As String)
    
    On Error GoTo CheckError
    Err.Clear
    
    Dim myBinder As Object
    
    '
    '   The binder program will get a new object
    '   if Binder is running.
    '
    Set myBinder = CreateObject("OfficeBinder.Binder")
    
    With myBinder
        '
        '    Open the file as default binder object
        '
        .Open msFile
         
        ' .Sections.Add filename:=msFile
        ' .Visible = True
        '.PrintOut what:=bindPrintVisibleSections
    End With
    
    myBinder.Close SaveChanges:=False
    Set myBinder = Nothing

    distillIt (pdfFile)

    Exit Sub

CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        myBinder.Close SaveChanges:=False
        myBinder.Quit
        Set myBinder = Nothing
        Exit Sub
    End If
End Sub

Public Sub frame2pdf(ByVal msFile As String, _
        ByVal pdfFile As String)
    
    On Error GoTo CheckError
    Err.Clear
    
    distillIt (pdfFile)

    Exit Sub

CheckError:

    '
    '    Print the actual error and then throw
    '    an exception so the calling program
    '    will know there was a problem.
    '
    If Err.Number <> 0 Then
        debuglog "Error " & Err.Number _
            & ": " & Err.Description
        Err.Raise Number:=vbObjectError + 9999
        Exit Sub
    End If
End Sub

Private Sub debuglog(ByVal msg As String)

    Dim FileNum As Integer

    FileNum = FreeFile
    Open "C:\olesrvr.log" For Append As FileNum
    Write #FileNum, "..... " & msg
    Close FileNum

    FileNum = FreeFile
    Open "C:\olesrvr\errormsg" For Append As FileNum
    Write #FileNum, "..... " & msg
    Close FileNum
End Sub

Private Sub distillIt(ByVal pdfFile As String)

    Dim pdf As PdfDistiller
    
    Set pdf = CreateObject("PdfDistiller.PdfDistiller.1")
    pdf.FileToPDF strInputPostScript:="C:\distOut.ps", _
        strOutputPDF:=pdfFile, strJobOptions:=""
    Set pdf = Nothing
End Sub
