

/*

**	netsock.h:  interface of the netsock class

*/



#ifndef NETSOCK_H

#define NETSOCK_H



//typedef int SOCKET;

#define MAXRECSIZE 8192		// network file buffer size



class netsock

{



public:



	netsock(int);		//  constructor of client socket



	~netsock(void);			//  destroy socket

	int	SendMsg(char*);		//  send msg on socket

	int	RecvMsg();		//  receive msg on socket

	int	SendFile(char*);	//  send file on socket

	int	RecvFile(char*);	//  receive file on socket

	int	RecvFileNP(char*);	//  RecvFile with No Protocol

	int	PassFile(netsock*);	//  pass a file through

	char*	getMsg();		//  get pointer to net message

	char*	getToken();		//  get next token from net message

	int	IsNetwork(void);	//  Is the client networked?

	void	Abort(char* msg);	//  abort the socket

	int	StatusMsg(char*);	//  send status msg on socket

	int	WarningMsg(char*);	//  send warning msg on socket

	int	NormalMsg(char*);	//  send normal msg on socket

	void	Close(void);		//  close the socket



private:

	int	Send(char*, int);	//  write raw message on socket

	int	Recv(char*, int);	//  read raw message from socket



	int		Rd;

	int		Wt;

	int		CLOSED;			//  is socket closed?

	int		MessageSize;

	char*		Message;

	char*		MsgBuf;

	int		firstToken;

};



extern	char* stripMsg(char*);

extern  char* strtoken(char*, char*);

extern	char* stripLine(char*);



#endif

